#!/usr/bin/perl

# R. Madariaga 26/06/06
#
#  DIBUJO DE LA SALIDA DE fd3d ou fd3dps 
#  ====>>> Usa PerlMagick!!!
#
#  Lee dimensiones, etc en los ficheros dyninput.dat
#
#  Necesita scale.dat para generar escala de color
#
#
use strict;
use Image::Magick;

my($q, $x);

#
#  BASIC OPTIONS
#
my $color=1 ;    #0 para gris
my $montage=1;  #si voulez monter les figure
my $jump=3;     #nombre d'instantanees a sauter
my $max_pict=15;#Nombre mnaximum d'instantanees
my $min_pict=1; #Nombre de la premiere instantanee
my $valor_min=0;
my $valor_max=1;
my @times;
my @figura;
my @indices;
my $output_file="plot_fault.gif";
#
#  DECODE OPTIONS IMPROVED
#
use Getopt::Std;
#my ($opt_v,$opt_h,$opt_p,$opt_c,$opt_j);

my %args=();
getopts("vhp:j:c:",\%args);
die "Version du 12/06/2006 \n Usage: $0 [-p number_pictures] [-j jump] [-c color]\n" if $args{v};
die "Version du 12/06/2006 \n Usage: $0 [-p number_pictures] [-j jump] [-c color]\n" if $args{h};

$jump=$args{j} if $args{j};
$max_pict=$args{p}  if $args{p};
$color=$args{c} if $args{c};
print "encontro opciones jump = $jump, max_pict = $max_pict color = $color\n";
#die;
#
#  GENERA ESCALA DE COLOR
#

my $scale=echelle();
    warn "$x" if "$x";

#
#  ===============================================
#  Read the parameter file  input.dat
#  ===============================================
#

my $source = "../input.dat";
my ($dx,$dt,$nt,$nx,$ny, $nskip)=get_input_data($source);

$nx=$nx;
#
# Determine size of images stored by dyna3d
#

my $Deltat= $dt*$nskip*$jump;

print " dt = $dt, dx = $dx\n";


print " valeurs nt =  $nt nx=$nx ny=$ny \n";

print " ntskip = $nskip Delta t = $Deltat \n";

my $itt=int($nt/$nskip);

#
#  ===============================================
#      PLOT SLIP RATE
#  ===============================================
#

$source = "sliprate.res.gz";

my $vx=plot_field("sliprate.res.gz",$nx,$ny,$itt,"sliprate (m/s)");

#
#  ===============================================
#      PLOT SLIP
#  ===============================================
#

my $vy=plot_field("slip.res.gz",$nx,$ny,$itt,"slip (m)");

#
#  ===============================================
#      PLOT STRESS 
#  ===============================================
#
my $vz=plot_field("ssx3d.res.gz",$nx,$ny,$itt,"stress (MPa)");

#
#  ===============================================
#     MONTAGE FINAL 
#  ===============================================
#
if($montage){   
my  $tile = "3x1";
my $largeur = $vx->Get('width');my $hauteur = $vx->Get('height');
my  $geometry="$largeur"."x"."$hauteur+10+10";

my   $final = Image::Magick->new;

  $final=$vx->Copy();
  $final->[1]=$vy->Copy();
  $final->[2]=$vz->Copy(); 

my  $s= $final->Montage(geometry=>$geometry, tile=> $tile,
			background => 'white',
			borderwidth => 0, shadow => 'False',
			mode => 'Unframe');
  #TITULO
my  $largeur = $s->Get('width');my $hauteur = $s->Get('height');

  $s->Annotate(stroke=>'Navy',pointsize=>19,font=>'Helvetica',
	       text=>'Dynamic circular fault',
	       align=>'Center',x=>$largeur/2, y=>25);
  
  $s->Write($output_file);
  
  $s->Display();
}

print "ze end\n";


#
#  =============================================================
#                  DIVIDE NEW  ROUTINE 
#  =============================================================
#

sub divide_new{
my($source, $output,$nx,$ny,$itt)=@_;
#
#READ ASCII DATA IN THE RIGHT ORDER
#
print "source = $source\n";

open(IN,"gunzip -dc $source |") || die "Cannot open $source\n";

my $size=$nx*$ny;
my $index = 1;
my $num_picture=0;
my $fsave=1;

my @imag;

print "nx, ny, size = $nx  $ny  $size\n";
undef @figura;
undef @indices;
undef @times;
push @indices,$index;
my $index_glob=0;
my $iy; my $ix; my $i;
my $value;
for($i=0;$i<$itt;$i++){
  undef @imag;
  my $vmin=0; my $vmax=0;
  for($iy=0;$iy<$ny;$iy++){
    for($ix=0;$ix<$nx;$ix++){
       my $value=<IN>;
       chomp($value);
       push @imag,$value;
     }
  }
#  chomp($value=<IN>);
#  print "last value of picture $i was $value  " if ($value ne "=="); 

  $num_picture++;
  if($jump>1){
    $fsave=($num_picture%$jump==1)?1:0;
  }else{

    $fsave=1;
  }
  $fsave=0 if($num_picture<=$min_pict);
  $fsave=0 if($index>$max_pict);
  my $j, my $val;
  if($fsave){
    $j=0;
    while($j<=$#imag){
      $val=$imag[$j++];
      push(@figura, $val);
    }
    $index_glob =$#figura;
    push (@indices,$index_glob);
    $index++;
    push @times,$i;
  }
}
close(IN);
#$num_picture--;
$index--;
print "divide_new::read $num_picture pictures from $source saved $index\n";
return($index);
}

#
#  =============================================================
#                  GET SCALE FOR THE IMAGE
#  =============================================================
#
sub get_scale_new{
  my ($nx, $ny, $indice) = @_;
  my $min=+1e37; my $max=-1e37;
  my $init=$indices[$indice-1]; 
  my $final=$indices[$indice-1]+($nx)*$ny;
  my $i; my $value;
  for($i=$init;$i<$final;$i++){
    $value = $figura[$i];
    $min = $value if $value<$min;
    $max = $value if $value>$max;
  }
  $valor_min=$min;$valor_max=$max;
  return ($valor_min,$valor_max);
}

#
#  =============================================================
#                 Convert image with a color map
#  =============================================================
#
sub convert_ppm{
  my ($nx, $ny, $ppmfil, $input,$colorcode,$scaling,$vmin,$vmax) = @_;

  open(ECH,">$ppmfil")  || die "cannot open $ppmfil\n";
  open(INP,"<$input") || die "cannot open $input\n";
  
  print ECH "P6\n",$nx,"\t",$ny,"\n","255\n"; 
  
  my @imag;
  my @inpt;
  
  my $min=+1e37; my $max=-1e37;
  my ($linea, $value);
  while($linea=<INP>){
    chomp $linea;
    $linea =~ s/^\s+//;
    $linea =~ s/\s+$//;
    @inpt = split('\s+',$linea);
    foreach $value (@inpt){
      chomp $value;
      push(@imag,$value);
      $min = $value if $value<$min;
      $max = $value if $value>$max;
    }
  }
  my $size=$#imag;
  
  if($scaling=~"auto"){
    $vmin=$min;$vmax=$max;
#    print "auto:found min max = $min, $max\n";
  }
 
  while($value=shift(@imag)){
#    $value=$vmin if($value<$vmin);
#    $value=$vmax if($value>$vmax);
    my $trip = palette($value,$vmin,$vmax,$colorcode);
    print ECH $trip;
  }
  
  close(ECH);

  close(INP);
}

#
# Palete conversion
#
sub palette{
  my ($value,$vmin,$vmax,$colorcode)=@_;
  my ($coef, @triple,$elem);
  $coef = 255./($vmax-$vmin); 
  $elem = $coef*($value - $vmin);
  if($colorcode==2){
    $elem = $elem/255.;
    $triple[0]=255*sqrt( $elem);
    $triple[1]=255*( $elem*$elem*$elem);
    $triple[2]=255*sin(6.283*$elem); $triple[2]=0 if $triple[2]<0.;
  }elsif($colorcode==3){
    $elem = $elem/255.;
    $triple[0]=0;
    $triple[1]=255*(1-abs(sin(3.1416*$elem)));
    $triple[2]=255*$elem;
  }else{    
    if($elem<32.){
      $triple[0]=int( 0);
      $triple[1]=int( 0);
	$triple[2]=int( (4.*$elem+128));
    }
    if($elem>=32 && $elem<96){
      $triple[0]=int( 0);
      $triple[1]=int( 4.*($elem-32));
      $triple[2]=int( (255));
    }
    if($elem>=96 && $elem<160){
      $triple[0]=int( 4*($elem-96));
      $triple[1]=int( (255));
      $triple[2]=int( (255-4.*($elem-96)));
    }
    if($elem>=160.&& $elem<224){
      $triple[0]=int( (255));
      $triple[1]=int( (255 - 4.*($elem-160.)));
      $triple[2]=int( 0.);
    }
    if($elem>=224&& $elem<256){
      $triple[0]=int( (255-4*($elem-224)));
      $triple[1]=int( (0.));
      $triple[2]=int( 0.);
    }
  }
  return pack("CCC",$triple[0], $triple[1], $triple[2]);
}
#
#  =============================================================
#                  CONVERTIR IMAGE EN  COULEUR 
#  ALGUN DIA HAY QUE ENTENDER porque nx=nx++1?
#  =============================================================
#

sub convert_new_ppm{
  my ($nx, $ny, $index,$colorcode,$scaling,$vmin,$vmax) = @_;

  my $imagen = sprintf "P6\n%d\t%d\n255\n",$nx,$ny;
  my $min=+1e37;my $max=-1e37;
  my $init=$indices[$index-1]; 
  my $final=$init+($nx)*$ny;
  my $i; my $value;
  if($scaling=~"auto"){
    for($i=$init;$i<=$final;$i++){
      $value=$figura[$i];
      $min = $value if $value<$min;
      $max = $value if $value>$max;
    }
    $vmin=$min;$vmax=$max;
    print "auto:found min max = $min, $max\n";
  }
# 
  for($i=$init;$i<=$final;$i++){
    $value=$figura[$i];
    my $tripl = palette($value,$vmin,$vmax,$colorcode);
    $imagen .=  $tripl;
  }
  return($imagen);
}
#
#  =============================================================
#                  ECHELLE DE COULEUR 
#  =============================================================
#

sub echelle{
my($salid)="scale.dat";

open(ECH,">$salid")  || die "File  $salid  was not opened, does it exists?\n";
my $pass = 0.1;
my $val = 0;
my $index2=0;
my $limit = 12.;	
my $vall;
while ($val < 10) {
    for ($vall = -$limit; $vall <= $limit; $vall += $pass) {
           print ECH $vall,"\n";
     $index2++;
    }
    $val++;
}

close(ECH);

&convert_ppm(241, 10, "echelle.ppm", "scale.dat",$color,"auto");

my $scale = Image::Magick->new;

$scale->Read("echelle.ppm");

return ($scale);
}
# =========================================================
#&echelle_couleurs($scale, $xcent, $ypos,$vmin,$vmax);
# =========================================================
#

sub echelle_couleurs{
my ($scale,$centro,$ypos,$label,$vmin,$vmax,$s)=@_;

my $scale_width=$scale->Get('width');
my $position= $centro-$scale_width/2;

my $vmin_annot=int($vmin*100.)/100.;
my $vmax_annot=int($vmax*100.)/100.;
#print "at echelle $vmin, $vmax -> $vmin_annot $vmin_annot\n";

$s->Composite(compose => 'over', image => $scale,
     x=>$position, y=>$ypos);

$s->Annotate(stroke=>'black',pointsize=>12,
    text=>$vmin_annot,align=>'Center',    x=>$position, y=>$ypos+20);

$position= $centro+$scale_width/2-10;
$s->Annotate(stroke=>'black',pointsize=>12,
    text=>$vmax_annot,align=>'Center',    x=>$position, y=>$ypos+20);

$s->Annotate(stroke=>'black',pointsize=>12,
    text=>$label,align=>'Center',x=>$centro, y=>$ypos+20);
}
#
#  Lit le fichier de donnes pour obtenir les echelles
#

sub get_input_data{
($source)=@_;
   open(SRC,"$source") || die "Cannot open $source\n";
print "ouvre $source\n";
   my ($T,$dt,$dx,$dy, $nbgx,$nedx, $nskpx, $nbgy,$nedy, $nskpy,$nskip);
   while(<SRC>) {
#  print $_;
    if (/\b(\d*)\bNT\b/) {/\b(\d*)\s*/;
			    $nt = $1; 
		      }
   if (/\b(\d*\.?\d*)\btmax\b/) {/\b(\d*\.?\d*)\s*/; 
			      $T = $1; 
		      }
   if (/\b(\d*)\bDH\b/) {/\b(\d*)\s*/;
			      $dx = $1; 
		      }
    if (/\b(\d*\.?\d*)\bDT\b/) {/\b(\d*\.?\d*)\s*/; 
			   $dt=$1;
		      }
    if (/\b(\d*)\bNBGX\b/) {/\b(\d*)\s*/;
			    $nbgx = $1; 
		      }
    if (/\b(\d*)\bNSKPX\b/) {/\b(\d*)\s*/;
			     $nskpx = $1; 
		      }
    if (/\b(\d*)\bNEDX\b/) {/\b(\d*)\s*/;
			       $nedx = $1; 
		      }
    if (/\b(\d*)\bNBGY\b/) {/\b(\d*)\s*/;
			       $nbgy = $1; 
		      }
    if (/\b(\d*)\bNEDY\b/) {/\b(\d*)\s*/;
			       $nedy = $1; 
			}
    if (/\b(\d*)\bNSKPY\b/) {/\b(\d*)\s*/;
			     $nskpy = $1; 
		      }
     if (/\b(\d*)\bNTISKP\b/) {/\b(\d*)\s*/;
			       $nskip = $1; 
		      }
   }
    close(SRC);
$T=$nt*$dt;
print "T =$T, dt =$dt\n";
my $nx = $nedx-$nbgx+1; my $ny=$nedy-$nbgy+1;
my $nt = $T/$dt;

return ($dx,$dt,$nt,$nx,$ny,$nskip);
}

#
#  ===============================================
#      PLOT Snapshots of field dans $fichero 
#  ===============================================
#

sub plot_field{
my ($fichero,$nx,$ny,$itt,$titulo) = @_;
my $output,my $index, my $ind;
#my @salida, @figura;
#
#  Divide the input file in snapshots
#
my $ind;
my $num_sections=divide_new($fichero, $output,$nx,$ny,$itt);

print "times @times\n";
my $index=int($num_sections);
my $vmax=-1.E+37;my $vmin=1.e+37;
my $valor_min,my $valor_max;
for ($ind=1; $ind<=$index;$ind++){
  ($valor_min,$valor_max)=&get_scale_new($nx,$ny, $ind);
  $vmin=$valor_min if ($vmin>$valor_min);
  $vmax=$valor_max if ($vmax<$valor_max);
}
$valor_max=$vmax; $valor_min=$vmin;
print "escala of $titulo : vmn, vmx = $valor_min, $valor_max\n";

#
#   Genrate ppm files from the *.ou files extracted from the input data
#
my $q = Image::Magick->new;
my $label, my $tiempo, my $imagen;
for($index=1; $index<=$num_sections;$index+=1){
  $imagen=&convert_new_ppm($nx,$ny, $index,$color, "fixed",$vmin,$vmax);
  my $tiempo= $Deltat*$times[$index-1];
  $x=$q->BlobToImage($imagen);
  warn "$x" if "$x";
  $label = "t = $tiempo";
  $q->[$index-1]->Label($label);
#  $q->[$index-1]->Draw(stroke=>'red', primitive=>'rectangle',
#		       strokewidth=>2.,points=>$rect);
}
$index--;
#my @figura;
#
# CREE FICHIER GIF
#
my $tile_line="1x".$num_sections;
my $tile = "$tile_line";

my $geometry  = "$nx"."x$ny+4+4";

my $v= $q->Montage(geometry=>$geometry, tile=> $tile_line,
	       background => 'white',font=>'Helvetica',
               borderwidth => 2, shadow => 'False',
	       mode => 'unframe');

$v->Border(geometry=>'40x80',color=>'white');

my $largeur = $v->Get('width');my $hauteur = $v->Get('height');
my ($titre)=split '\s+',$titulo;
$v->Annotate(stroke=>'navy', text=>$titre,
	     pointsize=>16, align=>'Center',
	     font=>'Helvetica',
	     x=> $largeur/2, y=>50);
#
# ANOTATIONS DU FICHIER NGIF
#

my $xcent=$largeur/2.;
&echelle_couleurs($scale, $xcent, $hauteur-50,$titulo,
		  $vmin,$vmax,$v);

undef $q;
return ($v);

}
